//********************** sx16app.c **************************
//* This file MUST be included into any application project
//* that uses sx16.dll. It provides DLL initialization.
//* Copyright (C) Sensoray 2001
//***********************************************************

/********************* IMPORTANT *********************
An option "Not using precompiled headers" must be set in project
properties for this file if it is an MFC project.
******************************************************/

//Function pointers are created here. All modules that call
//functions from sx16.dll must include sx16f.h

#define XFUNCX16( RTNTYPE, FUNCNAME )    RTNTYPE ( __stdcall *FUNCNAME )

#include <windows.h>
#include "..\x16dll\sm2288.h"
#include "sm2288f.h"

HINSTANCE hx16lib;

//Initialize pointers to exported functions.
//Return 0 if success

#define GETFPTR( FPTR, FNAM ) if( ( ( FARPROC )FPTR = GetProcAddress( hx16lib, FNAM) ) == NULL ) return ERR_FUNCADDR;

int GetFuncPtrs( void )
{
  GETFPTR ( X16_open,                   TEXT( "X16_open" ) );
  GETFPTR ( X16_register,               TEXT( "X16_register" ) );
  GETFPTR ( X16_unregister,             TEXT( "X16_unregister" ) );
  GETFPTR ( X16_close,                  TEXT( "X16_close" ) );
  GETFPTR ( X16_set_input,              TEXT( "X16_set_input" ) );
  GETFPTR ( X16_set_input_type,         TEXT( "X16_set_input_type" ) );
  GETFPTR ( X16_set_input_system,       TEXT( "X16_set_input_system" ) );
  GETFPTR ( X16_set_output_system,      TEXT( "X16_set_output_system" ) );
  GETFPTR ( X16_set_bitrate,            TEXT( "X16_set_bitrate" ) );
  GETFPTR ( X16_set_picsize,            TEXT( "X16_set_picsize" ) );
  GETFPTR ( X16_set_m,                  TEXT( "X16_set_m" ) );
  GETFPTR ( X16_set_n,                  TEXT( "X16_set_n" ) );
  GETFPTR ( X16_set_vbr,                TEXT( "X16_set_vbr" ) );
  GETFPTR ( X16_read_gpio,              TEXT( "X16_read_gpio" ) );
  GETFPTR ( X16_write_gpio,             TEXT( "X16_write_gpio" ) );
  GETFPTR ( X16_read,                   TEXT( "X16_read" ) );
  GETFPTR ( X16_write,                  TEXT( "X16_write" ) );
  GETFPTR ( X16_stop,                   TEXT( "X16_stop" ) );
  GETFPTR ( X16_pause,                  TEXT( "X16_pause" ) );
  GETFPTR ( X16_resume,                 TEXT( "X16_resume" ) );
  GETFPTR ( X16_set_brightness,         TEXT( "X16_set_brightness" ) );
  GETFPTR ( X16_set_contrast,           TEXT( "X16_set_contrast" ) );
  GETFPTR ( X16_set_saturation,         TEXT( "X16_set_saturation" ) );
  GETFPTR ( X16_set_colorbars,          TEXT( "X16_set_colorbars" ) );
  GETFPTR ( X16_set_filter,             TEXT( "X16_set_filter" ) );
  GETFPTR ( X16_set_volume,             TEXT( "X16_set_volume" ) );
  GETFPTR ( X16_set_mute,               TEXT( "X16_set_mute" ) );

  return( 0 );
}


// DLL open/close functions

int X16_DLLOpen( void )
{
  int err;

  hx16lib = LoadLibrary( TEXT( "x16.dll" ) );
  if( hx16lib == NULL )
    return ERR_LOADING_DLL;
  if( ( err = GetFuncPtrs( ) ) != 0 )
    {
    FreeLibrary( hx16lib );
    return( err );
    }
  return( 0 );
}


void X16_DLLClose( void )
{
  if( hx16lib )
    FreeLibrary( hx16lib );
}

